#!/usr/bin/env python3

import cic_eth.cli
import connexion
from cic_eth.graphql.config import config
from cic_eth.server import encoder

celery_app = cic_eth.cli.CeleryApp.from_config(config)
celery_app.set_default()


def create_app(test_config=None):
    app = connexion.App(__name__, specification_dir='./openapi/')
    if test_config:
        app.app.config.update(test_config)
    app.app.json_encoder = encoder.JSONEncoder
    app.add_api('server.yaml', arguments={
                'title': 'Grassroots Economics'}, pythonic_params=True)        
    return app


if __name__ == '__main__':
    app = create_app()
    app.run(port=5000)
