import logging

from cic_eth.server.celery_helper import call
from cic_eth.server.models import Token

log = logging.getLogger(__name__)


def get_default_token():
    """Retrieves the default fallback token of the custodial network

    :rtype: Token
    """

    data = call("default_token")
    log.debug(data)
    return Token(address=data['address'], symbol=data['symbol'], decimals=data['decimals'], name=data['name'])
