# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from cic_eth.server.models.base_model_ import Model
from cic_eth.server import util


class TokenBalance(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, address: str = None, converters: List[str] = None, balance_network: int = None, balance_incoming: int = None, balance_outgoing: int = None):
        """TokenBalance - a model defined in Swagger

        :param address: The address of this TokenBalance.  
        :type address: str
        :param converters: The converters of this TokenBalance.  
        :type converters: List[str]
        :param balance_network: The balance_network of this TokenBalance.  
        :type balance_network: int
        :param balance_incoming: The balance_incoming of this TokenBalance.  
        :type balance_incoming: int
        :param balance_outgoing: The balance_outgoing of this TokenBalance.  
        :type balance_outgoing: int
        :param balance_available: The balance_available of this TokenBalance.  
        :type balance_available: int
        """
        self.swagger_types = {
            'address': str,
            'converters': List[str],
            'balance_network': int,
            'balance_incoming': int,
            'balance_outgoing': int,
            'balance_available': int
        }

        self.attribute_map = {
            'address': 'address',
            'converters': 'converters',
            'balance_network': 'balance_network',
            'balance_incoming': 'balance_incoming',
            'balance_outgoing': 'balance_outgoing',
            'balance_available': 'balance_available'
        }
        self._address = address
        self._converters = converters
        self._balance_network = balance_network
        self._balance_incoming = balance_incoming
        self._balance_outgoing = balance_outgoing
        self._balance_available = int(
            balance_network) + int(balance_incoming) - int(balance_outgoing)

    @classmethod
    def from_dict(cls, dikt) -> 'TokenBalance':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The TokenBalance of this TokenBalance.  
        :rtype: TokenBalance
        """
        return util.deserialize_model(dikt, cls)

    @property
    def address(self) -> str:
        """Gets the address of this TokenBalance.


        :return: The address of this TokenBalance.
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address: str):
        """Sets the address of this TokenBalance.


        :param address: The address of this TokenBalance.
        :type address: str
        """

        self._address = address

    @property
    def converters(self) -> List[str]:
        """Gets the converters of this TokenBalance.


        :return: The converters of this TokenBalance.
        :rtype: List[str]
        """
        return self._converters

    @converters.setter
    def converters(self, converters: List[str]):
        """Sets the converters of this TokenBalance.


        :param converters: The converters of this TokenBalance.
        :type converters: List[str]
        """

        self._converters = converters

    @property
    def balance_network(self) -> int:
        """Gets the balance_network of this TokenBalance.


        :return: The balance_network of this TokenBalance.
        :rtype: int
        """
        return self._balance_network

    @balance_network.setter
    def balance_network(self, balance_network: int):
        """Sets the balance_network of this TokenBalance.


        :param balance_network: The balance_network of this TokenBalance.
        :type balance_network: int
        """

        self._balance_network = balance_network

    @property
    def balance_incoming(self) -> int:
        """Gets the balance_incoming of this TokenBalance.


        :return: The balance_incoming of this TokenBalance.
        :rtype: int
        """
        return self._balance_incoming

    @balance_incoming.setter
    def balance_incoming(self, balance_incoming: int):
        """Sets the balance_incoming of this TokenBalance.


        :param balance_incoming: The balance_incoming of this TokenBalance.
        :type balance_incoming: int
        """

        self._balance_incoming = balance_incoming

    @property
    def balance_outgoing(self) -> int:
        """Gets the balance_outgoing of this TokenBalance.


        :return: The balance_outgoing of this TokenBalance.
        :rtype: int
        """
        return self._balance_outgoing

    @balance_outgoing.setter
    def balance_outgoing(self, balance_outgoing: int):
        """Sets the balance_outgoing of this TokenBalance.


        :param balance_outgoing: The balance_outgoing of this TokenBalance.
        :type balance_outgoing: int
        """

        self._balance_outgoing = balance_outgoing

    @property
    def balance_available(self) -> int:
        """Gets the balance_available of this TokenBalance.


        :return: The balance_available of this TokenBalance.
        :rtype: int
        """
        return self._balance_available

    @balance_available.setter
    def balance_available(self, balance_available: int):
        """Sets the balance_available of this TokenBalance.


        :param balance_available: The balance_available of this TokenBalance.
        :type balance_available: int
        """

        self._balance_available = balance_available
